<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- json-api.qdoc -->
  <title>Appendix C: The JSON API | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Appendix C: The JSON API</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="porting-to-qbs.html" />
  <link rel="next" href="attributions.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="porting-to-qbs.html">Appendix B: Migrating from Other Build Systems</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="attributions.html">Appendix D: Licenses and Code Attributions</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#packet-format">Packet Format</a></li>
<li class="level1"><a href="#messages">Messages</a></li>
<li class="level1"><a href="#the-hello-message">The <code>hello</code> Message</a></li>
<li class="level1"><a href="#resolving-a-project">Resolving a Project</a></li>
<li class="level1"><a href="#building-a-project">Building a Project</a></li>
<li class="level1"><a href="#cleaning-a-project">Cleaning a Project</a></li>
<li class="level1"><a href="#installing-a-project">Installing a Project</a></li>
<li class="level1"><a href="#canceling-an-operation">Canceling an Operation</a></li>
<li class="level1"><a href="#adding-and-removing-source-files">Adding and Removing Source Files</a></li>
<li class="level1"><a href="#the-get-op-op-run-op-op-environment-message">The <code>get-run-environment</code> Message</a></li>
<li class="level1"><a href="#the-get-op-op-generated-op-op-files-op-op-keyword-for-keyword-op-op-sources-message">The <code>get-generated-files-for-sources</code> Message</a></li>
<li class="level1"><a href="#closing-a-project">Closing a Project</a></li>
<li class="level1"><a href="#closing-the-session">Closing the Session</a></li>
<li class="level1"><a href="#progress-messages">Progress Messages</a></li>
<li class="level2"><a href="#the-task-op-op-started-message">The <code>task-started</code> Message</a></li>
<li class="level2"><a href="#the-task-op-op-progress-message">The <code>task-progress</code> Message</a></li>
<li class="level2"><a href="#the-keyword-new-keyword-op-op-max-op-op-progress-message">The <code>new-max-progress</code> Message</a></li>
<li class="level1"><a href="#messages-for-users">Messages for Users</a></li>
<li class="level2"><a href="#the-log-op-op-data-message">The <code>log-data</code> Message</a></li>
<li class="level2"><a href="#the-warning-message">The <code>warning</code> Message</a></li>
<li class="level1"><a href="#the-protocol-op-op-error-message">The <code>protocol-error</code> Message</a></li>
<li class="level1"><a href="#project-data">Project Data</a></li>
<li class="level2"><a href="#toplevelprojectdata">TopLevelProjectData</a></li>
<li class="level2"><a href="#plainprojectdata">PlainProjectData</a></li>
<li class="level2"><a href="#productdata">ProductData</a></li>
<li class="level2"><a href="#groupdata">GroupData</a></li>
<li class="level2"><a href="#artifactdata">ArtifactData</a></li>
<li class="level2"><a href="#modulepropertiesdata">ModulePropertiesData</a></li>
<li class="level1"><a href="#other-custom-data-types">Other Custom Data Types</a></li>
<li class="level2"><a href="#filepath">FilePath</a></li>
<li class="level2"><a href="#location">Location</a></li>
<li class="level2"><a href="#errorinfo">ErrorInfo</a></li>
<li class="level2"><a href="#datamode">DataMode</a></li>
<li class="level2"><a href="#loglevel">LogLevel</a></li>
<li class="level2"><a href="#environment">Environment</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Appendix C: The JSON API</h1>
<span class="subtitle"></span>
<!-- $$$json-api.html-description -->
<div class="descr"> <a name="details"></a>
<p>This API is the recommended way to provide Qbs support to an IDE. It is accessible via the <a href="cli-session.html">session</a> command.</p>
<a name="packet-format"></a>
<h2 id="packet-format">Packet Format</h2>
<p>All information is exchanged via <i>packets</i>, which have the following structure:</p>
<pre class="cpp">

  packet <span class="operator">=</span> <span class="string">&quot;qbsmsg:&quot;</span> <span class="operator">&lt;</span>payload length<span class="operator">&gt;</span> <span class="operator">[</span><span class="operator">&lt;</span>meta data<span class="operator">&gt;</span><span class="operator">]</span> <span class="operator">&lt;</span>line feed<span class="operator">&gt;</span> <span class="operator">&lt;</span>payload<span class="operator">&gt;</span>

</pre>
<p>First comes a fixed string indentifying the start of a packet, followed by the size of the actual data in bytes. After that, further meta data might follow. There is none currently, but future extensions might add some. A line feed character marks the end of the meta data section and is followed immediately by the payload, which is a single JSON object encoded in Base64 format. We call this object a <i>message</i>.</p>
<a name="messages"></a>
<h2 id="messages">Messages</h2>
<p>The message data is UTF8-encoded.</p>
<p>Most messages are either <i>requests</i> or <i>replies</i>. Requests are messages sent to Qbs via the session's standard input channel. Replies are messages sent by Qbs via the session's standard output channel. A reply always corresponds to one specific request. Every request (with the exception of the <a href="json-api.html#quit-message">quit request</a>) expects exactly one reply. A reply implies that the requested operation has finished. At the very least, it carries information about whether the operation succeeded, and often contains additional data specific to the respective request.</p>
<p>Every message object has a <code>type</code> property, which is a string that uniquely identifies the message type.</p>
<p>All requests block the session for other requests, including those of the same type. For instance, if client code wishes to restart building the project with different parameters, it first has to send a <a href="json-api.html#cancel-message">cancel</a> request, wait for the current build job's reply, and only then can it request another build. The only other message beside <a href="json-api.html#cancel-message">cancel</a> that can legally be sent while a request is currently being handled is the <a href="json-api.html#quit-message">quit</a> message.</p>
<p>A reply object may carry an <code>error</code> property, indicating that the respective operation has failed. If this property is not present, the request was successful. The format of the <code>error</code> property is described <a href="json-api.html#errorinfo">here</a>.</p>
<p>In the remainder of this page, we describe the structure of all messages that can be sent to and received from Qbs, respectively. The property tables may have a column titled <i>Mandatory</i>, whose values indicate whether the respective message property is always present. If this column is missing, all properties of the respective message are mandatory, unless otherwise noted.</p>
<a name="the-hello-message"></a>
<h2 id="the-hello-message">The <code>hello</code> Message</h2>
<p>This message is sent by Qbs exactly once, right after the session was started. It is the only message from Qbs that is not a response to a request. The value of the <code>type</code> property is <code>&quot;hello&quot;</code>, the other properties are as follows:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >api-level</td><td >int</td></tr>
<tr valign="top" class="even"><td >api-compat-level</td><td >int</td></tr>
</table></div>
<p>The value of <code>api-level</code> is increased whenever the API is extended, for instance by adding new messages or properties.</p>
<p>The value of <code>api-compat-level</code> is increased whenever incompatible changes are being done to this API. A tool written for API level <code>n</code> should refuse to work with a Qbs version with an API compatibility level greater than <code>n</code>, because it cannot guarantee proper behavior. This value will not change unless it is absolutely necessary.</p>
<p>The value of <code>api-compat-level</code> is always less than or equal to the value of <code>api-level</code>.</p>
<a name="resolving-a-project"></a>
<h2 id="resolving-a-project">Resolving a Project</h2>
<p>To instruct Qbs to load a project from disk, a request of type <code>resolve-project</code> is sent. The other properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >build-root</td><td ><a href="json-api.html#filepath">FilePath</a></td><td >yes</td></tr>
<tr valign="top" class="even"><td >configuration-name</td><td >string</td><td >no</td></tr>
<tr valign="top" class="odd"><td >data-mode</td><td ><a href="json-api.html#datamode">DataMode</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >dry-run</td><td >bool</td><td >no</td></tr>
<tr valign="top" class="odd"><td >environment</td><td ><a href="json-api.html#environment">Environment</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >error-handling-mode</td><td >string</td><td >no</td></tr>
<tr valign="top" class="odd"><td >fallback-provider-enabled</td><td >bool</td><td >no</td></tr>
<tr valign="top" class="even"><td >force-probe-execution</td><td >bool</td><td >no</td></tr>
<tr valign="top" class="odd"><td >log-time</td><td >bool</td><td >no</td></tr>
<tr valign="top" class="even"><td >log-level</td><td ><a href="json-api.html#loglevel">LogLevel</a></td><td >no</td></tr>
<tr valign="top" class="odd"><td >module-properties</td><td >list of strings</td><td >no</td></tr>
<tr valign="top" class="even"><td >overridden-properties</td><td >object</td><td >no</td></tr>
<tr valign="top" class="odd"><td >project-file-path</td><td ><a href="json-api.html#filepath">FilePath</a></td><td >if resolving from scratch</td></tr>
<tr valign="top" class="even"><td >restore-behavior</td><td >string</td><td >no</td></tr>
<tr valign="top" class="odd"><td >settings-directory</td><td >string</td><td >no</td></tr>
<tr valign="top" class="even"><td >top-level-profile</td><td >string</td><td >no</td></tr>
<tr valign="top" class="odd"><td >wait-lock-build-graph</td><td >bool</td><td >no</td></tr>
</table></div>
<p>The <code>environment</code> property defines the environment to be used for resolving the project, as well as for all subsequent Qbs operations on this project.</p>
<p>The <code>error-handling-mode</code> specifies how Qbs should deal with issues in project files, such as assigning to an unknown property. The possible values are <code>&quot;strict&quot;</code> and <code>&quot;relaxed&quot;</code>. In strict mode, Qbs will immediately abort and set the reply's <code>error</code> property accordingly. In relaxed mode, Qbs will continue to resolve the project if possible. A <a href="json-api.html#warning-message">warning message</a> will be emitted for every error that was encountered, and the reply's <code>error</code> property will <i>not</i> be set. The default error handling mode is <code>&quot;strict&quot;</code>.</p>
<p>If the <code>log-time</code> property is <code>true</code>, then Qbs will emit <a href="json-api.html#log-data">log-data</a> messages containing information about which part of the operation took how much time.</p>
<p>The <code>module-properties</code> property lists the names of the module properties which should be contained in the <a href="json-api.html#productdata">product data</a> that will be sent in the reply message. For instance, if the project to be resolved is C++-based and the client code is interested in which C++ version the code uses, then <code>module-properties</code> would contain <code>&quot;cpp.cxxLanguageVersion&quot;</code>.</p>
<p>The <code>overridden-properties</code> property is used to override the values of module, product or project properties. The possible ways to specify keys are described <a href="language-introduction.html#overriding-property-values-from-the-command-line">here</a>.</p>
<p>The <code>restore-behavior</code> property specifies if and how to make use of an existing build graph. The value <code>&quot;restore-only&quot;</code> indicates that a build graph should be loaded from disk and used as-is. In this mode, it is an error if the build graph file does not exist. The value <code>&quot;resolve-only&quot;</code> indicates that the project should be resolved from scratch and that an existing build graph should be ignored. In this mode, it is an error if the <code>&quot;project-file-path&quot;</code> property is not present. The default value is <code>&quot;restore-and-track-changes&quot;</code>, which uses an existing build graph if possible and re-resolves the project if no build graph was found or if the parameters are different from the ones used when the project was last resolved.</p>
<p>The <code>top-level-profile</code> property specifies which Qbs profile to use for resolving the project. It corresponds to the <code>profile</code> key when using the <a href="cli-resolve.html">resolve</a> command.</p>
<p>All other properties correspond to command line options of the <a href="cli-resolve.html">resolve</a> command, and their semantics are described there.</p>
<p>When the project has been resolved, Qbs will reply with a <code>project-resolved</code> message. The possible properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >error</td><td ><a href="json-api.html#errorinfo">ErrorInfo</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >project-data</td><td ><a href="json-api.html#toplevelprojectdata">TopLevelProjectData</a></td><td >no</td></tr>
</table></div>
<p>The <code>error-info</code> property is present if and only if the operation failed. The <code>project-data</code> property is present if and only if the conditions stated by the request's <code>data-mode</code> property are fulfilled.</p>
<p>All other project-related requests need a resolved project to operate on. If there is none, they will fail.</p>
<p>There is at most one resolved project per session. If client code wants to open several projects or one project in different configurations, it needs to start additional sessions.</p>
<a name="building-a-project"></a>
<h2 id="building-a-project">Building a Project</h2>
<p>To build a project, a request of type <code>build-project</code> is sent. The other properties, none of which are mandatory, are listed below:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >active-file-tags</td><td >string list</td></tr>
<tr valign="top" class="even"><td >changed-files</td><td ><a href="json-api.html#filepath">FilePath</a> list</td></tr>
<tr valign="top" class="odd"><td >check-outputs</td><td >bool</td></tr>
<tr valign="top" class="even"><td >check-timestamps</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >clean-install-root</td><td >bool</td></tr>
<tr valign="top" class="even"><td >data-mode</td><td ><a href="json-api.html#datamode">DataMode</a></td></tr>
<tr valign="top" class="odd"><td >dry-run</td><td >bool</td></tr>
<tr valign="top" class="even"><td >command-echo-mode</td><td >string</td></tr>
<tr valign="top" class="odd"><td >enforce-project-job-limits</td><td >bool</td></tr>
<tr valign="top" class="even"><td >files-to-consider</td><td ><a href="json-api.html#filepath">FilePath</a> list</td></tr>
<tr valign="top" class="odd"><td >install</td><td >bool</td></tr>
<tr valign="top" class="even"><td >job-limits</td><td >list of objects</td></tr>
<tr valign="top" class="odd"><td >keep-going</td><td >bool</td></tr>
<tr valign="top" class="even"><td >log-level</td><td ><a href="json-api.html#loglevel">LogLevel</a></td></tr>
<tr valign="top" class="odd"><td >log-time</td><td >bool</td></tr>
<tr valign="top" class="even"><td >max-job-count</td><td >int</td></tr>
<tr valign="top" class="odd"><td >module-properties</td><td >list of strings</td></tr>
<tr valign="top" class="even"><td >products</td><td >list of strings or <code>&quot;all&quot;</code></td></tr>
</table></div>
<p>All boolean properties except <code>install</code> default to <code>false</code>.</p>
<p>The <code>active-file-tags</code> and <code>files-to-consider</code> are used to limit the build to certain output tags and/or source files. For instance, if only C/C++ object files should get built, then <code>active-file-tags</code> would be set to <code>&quot;obj&quot;</code>.</p>
<p>The objects in a <code>job-limits</code> array consist of a string property <code>pool</code> and an int property <code>limit</code>.</p>
<p>If the <code>log-time</code> property is <code>true</code>, then Qbs will emit <a href="json-api.html#log-data">log-data</a> messages containing information about which part of the operation took how much time.</p>
<p>If <code>products</code> is an array, the elements must correspond to the <code>full-display-name</code> property of previously retrieved <a href="json-api.html#productdata">ProductData</a>, and only these products will get built. If <code>products</code> is the string <code>&quot;all&quot;</code>, then all products in the project will get built. If <code>products</code> is not present, then products whose <a href="qml-qbslanguageitems-product.html#builtByDefault-prop">builtByDefault</a> property is <code>false</code> will be skipped.</p>
<p>The <code>module-properties</code> property has the same meaning as in the <a href="json-api.html#resolving-a-project">resolve-project</a> request.</p>
<p>All other properties correspond to options of the <a href="cli-build.html">build</a> command.</p>
<p>When the build has finished, Qbs will reply with a <code>project-built</code> message. The possible properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >error</td><td ><a href="json-api.html#errorinfo">ErrorInfo</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >project-data</td><td ><a href="json-api.html#toplevelprojectdata">TopLevelProjectData</a></td><td >no</td></tr>
</table></div>
<p>The <code>error-info</code> property is present if and only if the operation failed. The <code>project-data</code> property is present if and only if the conditions stated by the request's <code>data-mode</code> property are fulfilled.</p>
<p>Unless the <code>command-echo-mode</code> value is <code>&quot;silent&quot;</code>, a message of type <code>command-description</code> is emitted for every command to be executed. It consists of two string properties <code>highlight</code> and <code>message</code>, where <code>message</code> is the message to present to the user and <code>highlight</code> is a hint on how to display the message. It corresponds to the <a href="commands.html">Command</a> property of the same name.</p>
<p>For finished process commands, a message of type <code>process-result</code> might be emitted. The other properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >arguments</td><td >list of strings</td></tr>
<tr valign="top" class="even"><td >error</td><td >string</td></tr>
<tr valign="top" class="odd"><td >executable-file-path</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >exit-code</td><td >int</td></tr>
<tr valign="top" class="odd"><td >stderr</td><td >list of strings</td></tr>
<tr valign="top" class="even"><td >stdout</td><td >list of strings</td></tr>
<tr valign="top" class="odd"><td >success</td><td >bool</td></tr>
<tr valign="top" class="even"><td >working-directory</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
</table></div>
<p>The <code>error</code> string is one of <code>&quot;failed-to-start&quot;</code>, <code>&quot;crashed&quot;</code>, <code>&quot;timed-out&quot;</code>, <code>&quot;write-error&quot;</code>, <code>&quot;read-error&quot;</code> and <code>&quot;unknown-error&quot;</code>. Its value is not meaningful unless <code>success</code> is <code>false</code>.</p>
<p>The <code>stdout</code> and <code>stderr</code> properties describe the process's standard output and standard error output, respectively, split into lines.</p>
<p>The <code>success</code> property is <code>true</code> if the process finished without errors and an exit code of zero.</p>
<p>The other properties describe the exact command that was executed.</p>
<p>This message is only emitted if the process failed or it has printed data to one of the output channels.</p>
<a name="cleaning-a-project"></a>
<h2 id="cleaning-a-project">Cleaning a Project</h2>
<p>To remove a project's build artifacts, a request of type <code>clean-project</code> is sent. The other properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >dry-run</td><td >bool</td></tr>
<tr valign="top" class="even"><td >keep-going</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >log-level</td><td ><a href="json-api.html#loglevel">LogLevel</a></td></tr>
<tr valign="top" class="even"><td >log-time</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >products</td><td >list of strings</td></tr>
</table></div>
<p>The elements of the <code>products</code> array correspond to a <code>full-display-name</code> of a <a href="json-api.html#productdata">ProductData</a>. If this property is present, only the respective products' artifacts are removed.</p>
<p>If the <code>log-time</code> property is <code>true</code>, then Qbs will emit <a href="json-api.html#log-data">log-data</a> messages containing information about which part of the operation took how much time.</p>
<p>All other properties correspond to options of the <a href="cli-clean.html">clean</a> command.</p>
<p>None of these properties are mandatory.</p>
<p>After all artifacts have been removed, Qbs replies with a <code>project-cleaned</code> message. If the operation was successful, this message has no properties. Otherwise, a property <code>error</code> of type <a href="json-api.html#errorinfo">ErrorInfo</a> indicates what went wrong.</p>
<a name="installing-a-project"></a>
<h2 id="installing-a-project">Installing a Project</h2>
<p>Installing is normally part of the <a href="json-api.html#building-a-project">build</a> process. To do it in a separate step, the <code>install</code> property is set to <code>false</code> when building and a dedicated <code>install-project</code> message is sent. The other properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >clean-install-root</td><td >bool</td></tr>
<tr valign="top" class="even"><td >dry-run</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >install-root</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >keep-going</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >log-level</td><td ><a href="json-api.html#loglevel">LogLevel</a></td></tr>
<tr valign="top" class="even"><td >log-time</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >products</td><td >list of strings</td></tr>
<tr valign="top" class="even"><td >use-sysroot</td><td >bool</td></tr>
</table></div>
<p>The elements of the <code>products</code> array correspond to a <code>full-display-name</code> of a <a href="json-api.html#productdata">ProductData</a>. If this property is present, only the respective products' artifacts are installed.</p>
<p>If the <code>log-time</code> property is <code>true</code>, then Qbs will emit <a href="json-api.html#log-data">log-data</a> messages containing information about which part of the operation took how much time.</p>
<p>If the <code>use-sysroot</code> property is <code>true</code> and <code>install-root</code> is not present, then the install root will be <a href="qml-qbsmodules-qbs.html#sysroot-prop">qbs.sysroot</a>.</p>
<p>All other properties correspond to options of the <a href="cli-install.html">install</a> command.</p>
<p>None of these properties are mandatory.</p>
<a name="cancel-message"></a><a name="canceling-an-operation"></a>
<h2 id="canceling-an-operation">Canceling an Operation</h2>
<p>Potentially long-running operations can be aborted using the <code>cancel-job</code> request. This message does not have any properties. There is no dedicated reply message; instead, the usual reply for the request associated with the currently running operation will be sent, with the <code>error</code> property set to indicate that it was canceled.</p>
<p>If there is no operation in progress, this request will have no effect. In particular, if it arrives after the operation that it was supposed to cancel has already finished (i.e&#x2e; there is a race condition), the reply received by client code will not contain a cancellation-related error.</p>
<a name="adding-and-removing-source-files"></a>
<h2 id="adding-and-removing-source-files">Adding and Removing Source Files</h2>
<p>Source files can be added to and removed from Qbs project files with the <code>add-files</code> and <code>remove-files</code> messages, respectively. These two requests have the same set of properties:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >files</td><td ><a href="json-api.html#filepath">FilePath</a> list</td></tr>
<tr valign="top" class="even"><td >group</td><td >string</td></tr>
<tr valign="top" class="odd"><td >product</td><td >string</td></tr>
</table></div>
<p>The <code>files</code> property specifies which files should be added or removed.</p>
<p>The <code>product</code> property corresponds to the <code>full-display-name</code> of a <a href="json-api.html#productdata">ProductData</a> and specifies to which product to apply the operation.</p>
<p>The <code>group</code> property corresponds to the <code>name</code> of a <a href="json-api.html#groupdata">GroupData</a> and specifies to which group in the product to apply the operation.</p>
<p>After the operation has finished, Qbs replies with a <code>files-added</code> and <code>files-removed</code> message, respectively. Again, the properties are the same:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >error</td><td ><a href="json-api.html#errorinfo">ErrorInfo</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >failed-files</td><td ><a href="json-api.html#filepath">FilePath</a> list</td><td >no</td></tr>
<tr valign="top" class="odd"><td >project-data</td><td ><a href="json-api.html#toplevelprojectdata">TopLevelProjectData</a></td><td >no</td></tr>
</table></div>
<p>If the <code>error</code> property is present, the operation has at least partially failed and <code>failed-files</code> will list the files that could not be added or removed.</p>
<p>If the project data has changed as a result of the operation (which it should unless the operation failed completely), then the <code>project-data</code> property will contain the updated project data.</p>
<a name="the-get-op-op-run-op-op-environment-message"></a>
<h2 id="the-get-op-op-run-op-op-environment-message">The <code>get-run-environment</code> Message</h2>
<p>This request retrieves the full run environment for a specific executable product, taking into account the <a href="qml-qbslanguageitems-module.html#setupRunEnvironment-prop">setupRunEnvironment</a> scripts of all modules pulled in by the product. The properties are as follows:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >base-environment</td><td ><a href="json-api.html#environment">Environment</a></td><td >no</td></tr>
<tr valign="top" class="even"><td >config</td><td >list of strings</td><td >no</td></tr>
<tr valign="top" class="odd"><td >product</td><td >string</td><td >yes</td></tr>
</table></div>
<p>The <code>base-environment</code> property defines the environment into which the Qbs-specific values should be merged.</p>
<p>The <code>config</code> property corresponds to the <a href="cli-run.html#setup-run-env-config">--setup-run-env-config</a> option of the <a href="cli-run.html">run</a> command.</p>
<p>The <code>product</code> property specifies the product whose environment to retrieve. The value must correspond to the <code>full-display-name</code> of some <a href="json-api.html#productdata">ProductData</a> in the project.</p>
<p>Qbs will reply with a <code>run-environment</code> message. In case of failure, it will contain a property <code>error</code> of type <a href="json-api.html#errorinfo">ErrorInfo</a>, otherwise it will contain a property <code>full-environment</code> of type <a href="json-api.html#environment">Environment</a>.</p>
<a name="the-get-op-op-generated-op-op-files-op-op-keyword-for-keyword-op-op-sources-message"></a>
<h2 id="the-get-op-op-generated-op-op-files-op-op-keyword-for-keyword-op-op-sources-message">The <code>get-generated-files-for-sources</code> Message</h2>
<p>This request allows client code to retrieve information about which artifacts are generated from a given source file. Its sole property is a list <code>products</code>, whose elements are objects with the two properties <code>full-display-name</code> and <code>requests</code>. The first identifies the product to which the requests apply, and it must match the property of the same name in a <a href="json-api.html#productdata">ProductData</a> in the project. The latter is a list of objects with the following properties:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >source-file</td><td ><a href="json-api.html#filepath">FilePath</a></td><td >yes</td></tr>
<tr valign="top" class="even"><td >tags</td><td >list of strings</td><td >no</td></tr>
<tr valign="top" class="odd"><td >recursive</td><td >bool</td><td >no</td></tr>
</table></div>
<p>The <code>source-file</code> property specifies a source file in the respective product.</p>
<p>The <code>tags</code> property constrains the possible file tags of the generated files to be matched. This is relevant if a source files serves as input to more than one rule or the rule generates more than one type of output.</p>
<p>If the <code>recursive</code> property is <code>true</code>, files indirectly generated from the source file will also be returned. The default is <code>false</code>. For instance, íf this property is enabled for a C++ source file, the final link target (e.g&#x2e; a library or an application executable) will be returned in addition to the object file.</p>
<p>Qbs will reply with a <code>generated-files-for-sources</code> message, whose structure is similar to the request. It also has a single object list property <code>products</code>, whose elements consist of a string property <code>full-display-name</code> and an object list property <code>results</code>. The properties of these objects are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >source-file</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >generated-files</td><td ><a href="json-api.html#filepath">FilePath</a> list</td></tr>
</table></div>
<p>The <code>source-file</code> property corresponds to an entry of the same name in the request, and the <code>generated-files</code> are the files which are generated by Qbs rules that take the source file as an input, taking the constraints specified in the request into account.</p>
<p>Source files for which the list would be empty are not listed. Similarly, products for which the <code>results</code> list would be empty are also omitted.</p>
<p><b>Note: </b>The results may be incomplete if the project has not been fully built.</p><a name="closing-a-project"></a>
<h2 id="closing-a-project">Closing a Project</h2>
<p>A project is closed with a <code>release-project</code> message. This request has no properties.</p>
<p>Qbs will reply with a <code>project-released</code> message. If no project was open, the reply will contain an <code>error</code> property of type <a href="json-api.html#errorinfo">ErrorInfo</a>.</p>
<a name="quit-message"></a><a name="closing-the-session"></a>
<h2 id="closing-the-session">Closing the Session</h2>
<p>To close the session, a <code>quit</code> message is sent. This request has no properties.</p>
<p>Qbs will cancel all currently running operations and then close itself. No reply will be sent.</p>
<a name="progress-messages"></a>
<h2 id="progress-messages">Progress Messages</h2>
<p>While a request is being handled, Qbs may emit progress information in order to enable client code to display a progress bar.</p>
<a name="task-started"></a><a name="the-task-op-op-started-message"></a>
<h3 id="the-task-op-op-started-message">The <code>task-started</code> Message</h3>
<p>This is always the first progress-related message for a specific request. It appears at most once per request. It consists of a string property <code>description</code>, whose value can be displayed to users, and an integer property <code>max-progress</code> that indicates which progress value corresponds to 100 per cent.</p>
<a name="task-progress"></a><a name="the-task-op-op-progress-message"></a>
<h3 id="the-task-op-op-progress-message">The <code>task-progress</code> Message</h3>
<p>This message updates the progress via an integer property <code>progress</code>.</p>
<a name="new-max-progress"></a><a name="the-keyword-new-keyword-op-op-max-op-op-progress-message"></a>
<h3 id="the-keyword-new-keyword-op-op-max-op-op-progress-message">The <code>new-max-progress</code> Message</h3>
<p>This message is emitted if the original estimated maximum progress has to be corrected. Its integer property <code>max-progress</code> updates the value from a preceding <a href="json-api.html#task-started">task-started</a> message.</p>
<a name="messages-for-users"></a>
<h2 id="messages-for-users">Messages for Users</h2>
<p>There are two types of messages that purely contain information to be presented to users.</p>
<a name="log-data"></a><a name="the-log-op-op-data-message"></a>
<h3 id="the-log-op-op-data-message">The <code>log-data</code> Message</h3>
<p>This object has a string property <code>message</code>, which is the text to be shown to the user.</p>
<a name="warning-message"></a><a name="the-warning-message"></a>
<h3 id="the-warning-message">The <code>warning</code> Message</h3>
<p>This message has a single property <code>warning</code> of type <a href="json-api.html#errorinfo">ErrorInfo</a>.</p>
<a name="the-protocol-op-op-error-message"></a>
<h2 id="the-protocol-op-op-error-message">The <code>protocol-error</code> Message</h2>
<p>Qbs sends this message as a reply to a request with an unknown <code>type</code>. It contains an <code>error</code> property of type <a href="json-api.html#errorinfo">ErrorInfo</a>.</p>
<a name="project-data"></a>
<h2 id="project-data">Project Data</h2>
<p>If a request can alter the build graph data, the associated reply may contain a <code>project-data</code> property whose value is of type <a href="json-api.html#toplevelprojectdata">TopLevelProjectData</a>.</p>
<a name="toplevelprojectdata"></a>
<h3 id="toplevelprojectdata">TopLevelProjectData</h3>
<p>This data type represents the entire project. It has the same properties as <a href="json-api.html#plainprojectdata">PlainProjectData</a>. If it is part of a <code>project-resolved</code> message, these additional properties are also present:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >build-directory</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >build-graph-file-path</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="odd"><td >build-system-files</td><td ><a href="json-api.html#filepath">FilePath</a> list</td></tr>
<tr valign="top" class="even"><td >overridden-properties</td><td >object</td></tr>
<tr valign="top" class="odd"><td >profile-data</td><td >object</td></tr>
</table></div>
<p>The value of <code>build-directory</code> is the top-level build directory.</p>
<p>The <code>build-graph-file-path</code> value is the path to the build graph file.</p>
<p>The <code>build-system-files</code> value contains all Qbs project files, including modules and JavaScript helper files.</p>
<p>The value of <code>overridden-properties</code> is the one that was passed in when the project was last <a href="json-api.html#resolving-a-project">resolved</a>.</p>
<p>The <code>profile-data</code> property maps the names of the profiles used in the project to the respective property maps. Unless profile multiplexing is used, this object will contain exactly one property.</p>
<a name="plainprojectdata"></a>
<h3 id="plainprojectdata">PlainProjectData</h3>
<p>This data type describes a <a href="qml-qbslanguageitems-project.html">Project</a> item. The properties are as follows:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >is-enabled</td><td >bool</td></tr>
<tr valign="top" class="even"><td >location</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="odd"><td >name</td><td >string</td></tr>
<tr valign="top" class="even"><td >products</td><td ><a href="json-api.html#productdata">ProductData</a> list</td></tr>
<tr valign="top" class="odd"><td >sub-projects</td><td ><a href="json-api.html#plainprojectdata">PlainProjectData</a> list</td></tr>
</table></div>
<p>The <code>is-enabled</code> property corresponds to the project's <a href="qml-qbslanguageitems-project.html#condition-prop">condition</a>.</p>
<p>The <code>location</code> property is the exact position in a Qbs project file where the corresponding <a href="qml-qbslanguageitems-project.html">Project</a> item was defined.</p>
<p>The <code>products</code> and <code>sub-projects</code> are what the project has pulled in via its <a href="qml-qbslanguageitems-project.html#references-prop">references</a> property.</p>
<a name="productdata"></a>
<h3 id="productdata">ProductData</h3>
<p>This data type describes a <a href="qml-qbslanguageitems-product.html">Product</a> item. The properties are as follows:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >build-directory</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >dependencies</td><td >list of strings</td></tr>
<tr valign="top" class="odd"><td >full-display-name</td><td >string</td></tr>
<tr valign="top" class="even"><td >generated-artifacts</td><td ><a href="json-api.html#artifactdata">ArtifactData</a> list</td></tr>
<tr valign="top" class="odd"><td >groups</td><td ><a href="json-api.html#groupdata">GroupData</a> list</td></tr>
<tr valign="top" class="even"><td >is-enabled</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >is-multiplexed</td><td >bool</td></tr>
<tr valign="top" class="even"><td >is-runnable</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >location</td><td ><a href="json-api.html#location">Location</a></td></tr>
<tr valign="top" class="even"><td >module-properties</td><td ><a href="json-api.html#modulepropertiesdata">ModulePropertiesData</a></td></tr>
<tr valign="top" class="odd"><td >multiplex-configuration-id</td><td >string</td></tr>
<tr valign="top" class="even"><td >name</td><td >string</td></tr>
<tr valign="top" class="odd"><td >properties</td><td >object</td></tr>
<tr valign="top" class="even"><td >target-executable</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="odd"><td >target-name</td><td >string</td></tr>
<tr valign="top" class="even"><td >type</td><td >list of strings</td></tr>
<tr valign="top" class="odd"><td >version</td><td >string</td></tr>
</table></div>
<p>The <code>dependencies</code> are the names of products that occur in the (enabled) <a href="qml-qbslanguageitems-depends.html">Depends</a> items of this product.</p>
<p>The <code>generated-artifacts</code> are files that are created by the <a href="qml-qbslanguageitems-rule.html">rules</a> in this product.</p>
<p>The <code>groups</code> list corresponds to the <a href="qml-qbslanguageitems-group.html">Group</a> items in this product. In addition, a &quot;pseudo-group&quot; is created for the <a href="qml-qbslanguageitems-product.html#files-prop">files</a> property of the product itself. Its name is the same as the product's.</p>
<p>The <code>is-enabled</code> property corresponds to the product's <a href="qml-qbslanguageitems-product.html#condition-prop">condition</a>. A product may also get disabled if it contains errors and Qbs was was instructed to operate in relaxed mode when the project was <a href="json-api.html#resolving-a-project">resolved</a>.</p>
<p>The <code>is-multiplexed</code> property is true if and only if the product is <a href="multiplexing.html">multiplexed</a> over one ore more properties.</p>
<p>The <code>is-runnable</code> property indicates whether one of the product's target artifacts is an executable file. In that case, the file is available via the <code>target-executable</code> property.</p>
<p>The <code>location</code> property is the exact position in a Qbs project file where the corresponding <a href="qml-qbslanguageitems-product.html">Product</a> item was defined.</p>
<p>The <code>module-properties</code> object provides the values of the module properties that were requested when the project was <a href="json-api.html#resolving-a-project">resolved</a>.</p>
<p>The <code>name</code> property is the value given in the <a href="qml-qbslanguageitems-product.html#name-prop">Product item</a>, whereas <code>full-display-name</code> is a name that uniquely identifies the product in the entire project, even in the presence of multiplexing. In the absence of multiplexing, it is the same as <code>name</code>. In either case, it is suitable for being presented to users.</p>
<p>See the <a href="qml-qbslanguageitems-product.html">Product</a> item documentation for a description of the other properties.</p>
<a name="groupdata"></a>
<h3 id="groupdata">GroupData</h3>
<p>This data type describes a <a href="qml-qbslanguageitems-group.html">Group</a> item. The properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >is-enabled</td><td >bool</td></tr>
<tr valign="top" class="even"><td >location</td><td ><a href="json-api.html#location">Location</a></td></tr>
<tr valign="top" class="odd"><td >module-properties</td><td ><a href="json-api.html#modulepropertiesdata">ModulePropertiesData</a></td></tr>
<tr valign="top" class="even"><td >name</td><td >string</td></tr>
<tr valign="top" class="odd"><td >prefix</td><td >string</td></tr>
<tr valign="top" class="even"><td >source-artifacts</td><td ><a href="json-api.html#artifactdata">ArtifactData</a> list</td></tr>
<tr valign="top" class="odd"><td >source-artifacts-from-wildcards</td><td ><a href="json-api.html#artifactdata">ArtifactData</a> list</td></tr>
</table></div>
<p>The <code>is-enabled</code> property corresponds to the groups's <a href="qml-qbslanguageitems-group.html#condition-prop">condition</a>. However, if the group's product is disabled, this property will always be <code>false</code>.</p>
<p>The <code>location</code> property is the exact position in a Qbs project file where the corresponding <a href="qml-qbslanguageitems-group.html">Group</a> item occurs.</p>
<p>The <code>module-properties</code> object provides the values of the module properties that were requested when the project was <a href="json-api.html#resolving-a-project">resolved</a>. If no module properties are set on the Group level and the value would therefore be the same as in the group's product, then this property is omitted.</p>
<p>The <code>source-artifacts</code> list corresponds the the files listed verbatim in the group's <a href="qml-qbslanguageitems-group.html#files-prop">files</a> property.</p>
<p>The <code>source-artifacts-from-wildcards</code> list represents the the files expanded from wildcard entries in the group's <a href="qml-qbslanguageitems-group.html#files-prop">files</a> property.</p>
<p>See the <a href="qml-qbslanguageitems-group.html">Group</a> item documentation for a description of the other properties.</p>
<a name="artifactdata"></a>
<h3 id="artifactdata">ArtifactData</h3>
<p>This data type represents files that occur in the project, either as sources or as outputs of a rules. Qbs project files, on the other hand, are not artifacts. The properties are:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th></tr></thead>
<tr valign="top" class="odd"><td >file-path</td><td ><a href="json-api.html#filepath">FilePath</a></td></tr>
<tr valign="top" class="even"><td >file-tags</td><td >list of strings</td></tr>
<tr valign="top" class="odd"><td >install-data</td><td >object</td></tr>
<tr valign="top" class="even"><td >is-executable</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >is-generated</td><td >bool</td></tr>
<tr valign="top" class="even"><td >is-target</td><td >bool</td></tr>
<tr valign="top" class="odd"><td >module-properties</td><td ><a href="json-api.html#modulepropertiesdata">ModulePropertiesData</a></td></tr>
</table></div>
<p>The <code>install-data</code> property is an object whose <code>is-installable</code> property indicates whether the artifact gets installed. If so, then the <a href="json-api.html#filepath">FilePath</a> properties <code>install-file-path</code> and <code>install-root</code> provide further information.</p>
<p>The <code>is-target</code> property is true if the artifact is a target artifact of its product, that is, <code>is-generated</code> is true and <code>file-tags</code> intersects with the <a href="qml-qbslanguageitems-product.html#type-prop">product type</a>.</p>
<p>The <code>module-properties</code> object provides the values of the module properties that were requested when the project was <a href="json-api.html#resolving-a-project">resolved</a>. This property is only present for generated artifacts. For source artifacts, the value can be retrieved from their <a href="json-api.html#groupdata">group</a>.</p>
<p>The other properties should be self-explanatory.</p>
<a name="modulepropertiesdata"></a>
<h3 id="modulepropertiesdata">ModulePropertiesData</h3>
<p>This data type maps fully qualified module property names to their respective values.</p>
<a name="other-custom-data-types"></a>
<h2 id="other-custom-data-types">Other Custom Data Types</h2>
<p>There are a number of custom data types that serve as building blocks in various messages. They are described below.</p>
<a name="filepath"></a>
<h3 id="filepath">FilePath</h3>
<p>A <i>FilePath</i> is a string that describes a file or directory. FilePaths are always absolute and use forward slashes for separators, regardless of the host operating system.</p>
<a name="location"></a>
<h3 id="location">Location</h3>
<p>A <i>Location</i> is an object representing a file path and possibly also a position within the respective file. It consists of the following properties:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td >file-path</td><td ><a href="json-api.html#filepath">FilePath</a></td><td >yes</td></tr>
<tr valign="top" class="even"><td >line</td><td >int</td><td >no</td></tr>
<tr valign="top" class="odd"><td >column</td><td >int</td><td >no</td></tr>
</table></div>
<a name="errorinfo"></a>
<h3 id="errorinfo">ErrorInfo</h3>
<p>An <i>ErrorInfo</i> is an object representing error information. Its sole property <code>items</code> is an array of objects with the following structure:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Property</th><th >Type</th><th >Mandatory</th></tr></thead>
<tr valign="top" class="odd"><td ><code>message</code></td><td >string</td><td >yes</td></tr>
<tr valign="top" class="even"><td >location</td><td ><a href="json-api.html#location">Location</a></td><td >no</td></tr>
</table></div>
<a name="datamode"></a>
<h3 id="datamode">DataMode</h3>
<p>This is the type of the <code>data-mode</code> property in a <a href="json-api.html#resolving-a-project">resolve</a> or <a href="json-api.html#building-a-project">build</a> request. It is used to indicate under which circumstances the reply message should include the project data. The possible values have string type and are as follows:</p>
<ul>
<li><code>&quot;never&quot;</code>: Do not attach project data to the reply.</li>
<li><code>&quot;always&quot;</code>: Do attach project data to the reply.</li>
<li><code>&quot;only-if-changed&quot;</code>: Attach project data to the reply only if it is different from the current project data.</li>
</ul>
<p>The default value is <code>&quot;never&quot;</code>.</p>
<a name="loglevel"></a>
<h3 id="loglevel">LogLevel</h3>
<p>This is the type of the <code>log-level</code> property that can occur in various requests. It is used to indicate whether the client would like to receive <a href="json-api.html#log-data">log-data</a> and/or <a href="json-api.html#warning-message">warning</a> messages. The possible values have string type and are as follows:</p>
<ul>
<li>&quot;error&quot;: Do not log anything.</li>
<li>&quot;warning&quot;: Qbs may emit <a href="json-api.html#warning-message">warnings</a>, but no <a href="json-api.html#log-data">log-data</a> messages.</li>
<li>&quot;info&quot;: In addition to warnings, Qbs may emit informational <a href="json-api.html#log-data">log-data</a> messages.</li>
<li>&quot;debug&quot;: Qbs may emit debug output. No messages will be generated; instead, the standard error output channel will be used.</li>
</ul>
<p>The default value is <code>&quot;info&quot;</code>.</p>
<a name="environment"></a>
<h3 id="environment">Environment</h3>
<p>This data type describes a set of environment variables. It is an object whose keys are names of environment variables and whose values are the values of these environment variables.</p>
</div>
<!-- @@@json-api.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="porting-to-qbs.html">Appendix B: Migrating from Other Build Systems</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="attributions.html">Appendix D: Licenses and Code Attributions</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
